<template>
  <main>
    <ul>
      <li><a href="#leaderboard">Leaderboard</a></li>
      <li v-if="data.groups"><a href="#group-stats">Stats by group</a></li>
      <li><a href="#charts">Burndown Charts</a></li>
      <li><a href="#issues">Issue list</a></li>
    </ul>
    <overall-stats
      v-if="data.target"
      :status="data.status"
      :target="data.target"
      :total="total"
    />
    <section>
      <h2 id="leaderboard">Leaderboard</h2>
      <stats-table :data="folks" :headers="peopleFields">
        <template v-slot:row="{ entry }" v-if="isOngoing">
          <td>
            <person :handle="entry.name" />
          </td>
          <td>{{ entry.assigned }}</td>
          <td>{{ entry.closed }}</td>
          <td>{{ entry.total }}</td>
        </template>
        <template v-slot:row="{ entry }" v-else>
          <td>
            <person :handle="entry.name" />
          </td>
          <td>{{ entry.closed }}</td>
        </template>
      </stats-table>
    </section>
    <section v-if="data.groups">
      <h2 id="group-stats">Stats by group</h2>
      <label>
        <input type="checkbox" v-model="showTeamMembers" />
        Show team members and groups
      </label>
      <stats-table :data="groups" :headers="groupFields">
        <template v-slot:row="{ entry }">
          <td :style="{ maxWidth: '280px' }">
            <a v-if="entry.link" :href="entry.link">{{ entry.name }}</a>
            <strong v-else>{{ entry.name }}</strong>
            <template v-if="showTeamMembers">
              <small
                v-for="group in entry.groups"
                :key="group"
                style="line-height: 1.2em; display: block"
                >{{ group }}</small
              >
            </template>
          </td>
          <td :style="{ maxWidth: '200px' }" v-if="showTeamMembers">
            <small style="line-height: 1.2em; display: inline-block">{{
              entry.folks.join(" ")
            }}</small>
          </td>
          <td v-if="isOngoing">{{ entry.assigned }}</td>
          <td>{{ entry.closed }}</td>
          <td v-if="isOngoing">{{ entry.total }}</td>
          <td v-if="entry.target > 0">{{ entry.target }}</td>
          <td v-if="entry.completion >= 0">
            <div class="progress-wrapper">
              <value
                class="progress-completed"
                :value="entry.completion"
                :max="250"
              />
              <value
                class="progress-assigned"
                :value="entry.assigned / entry.target"
                :max="250"
              />
              <div
                v-if="entry.assigned && entry.completion"
                class="progress-total"
              >
                {{
                  Math.round(
                    (entry.completion + entry.assigned / entry.target) * 100
                  ) + "%"
                }}
              </div>
              <div class="progress-target" :style="{ left: 249 }" />
            </div>
          </td>
        </template>
      </stats-table>
    </section>
    <section class="charts">
      <h2 id="charts" class="fullwidth">Burndown Charts</h2>
      <chart-section v-bind="epic" v-for="epic of primaryEpics" />
      <details class="fullwidth" v-if="secondaryEpics.length">
        <summary>Secondary epic charts</summary>
        <div class="charts">
          <chart-section v-bind="epic" v-for="epic of secondaryEpics" />
        </div>
      </details>
    </section>
    <section v-if="issues.length">
      <h2 id="issues" class="fullwidth">Issues</h2>
      <stats-table :data="issues" :header-config="issueHeaderConfig">
        <template v-slot:row="{ entry }">
          <td>{{ entry.issueStatus }}</td>
          <td>
            <a :href="`https://gitlab.com${entry.webPath}`">#{{ entry.iid }}</a>
          </td>
          <td>
            <Milestone v-if="entry.milestone" :milestone="entry.milestone" />
          </td>
          <td>{{ entry.category.replace("component:", "") }}</td>
          <td v-if="entry.assignees.length">
            <template v-for="handle in entry.assignees">
              <person :handle="handle" />&nbsp;
            </template>
          </td>
          <td v-else>Unassigned</td>
          <td>{{ entry.labels }}</td>
        </template>
      </stats-table>
    </section>
  </main>
</template>
<script>
import StatsTable from "./components/StatsTable.vue";
import Value from "./components/Value.vue";
import OverallStats from "./components/OverallStats.vue";
import Person from "./components/Person.vue";
import Milestone from "./components/Milestone.vue";
import ChartSection from "./components/StatSection.vue";

import {
  enhanceIssues,
  groupByAssignee,
  groupPeopleByTeam,
} from "../lib/analysis";
import {
  defaultStats,
  FILTER_ANY,
  FILTER_EMPTY_ARRAY,
  FILTER_MULTI_SELECT,
  FILTER_TEXT_SEARCH,
  ISSUE_STATES,
  ONGOING,
  UNASSIGNED,
} from "../lib/constants";

export default {
  components: {
    ChartSection,
    Milestone,
    Person,
    OverallStats,
    Value,
    StatsTable,
  },
  data() {
    return {
      data: {},
      showTeamMembers: true,
    };
  },
  props: {
    statsPromise: {
      type: Promise,
    },
  },
  async mounted() {
    this.data = await this.statsPromise;
    await this.$nextTick();
    const { hash } = window.location;
    const el = hash && document.querySelector(hash);
    if (el) {
      el.scrollIntoView();
    }
  },
  computed: {
    primaryEpics() {
      return this.data?.epics?.filter((x) => x.primary) || [];
    },
    secondaryEpics() {
      return this.data?.epics?.filter((x) => !x.primary) || [];
    },
    issueHeaderConfig() {
      return [
        {
          field: "issueStatus",
          text: "Status",
          sortable: true,
          filterType: FILTER_MULTI_SELECT,
          defaultSort: true,
          filter: [
            { name: "Any status (Reset)", value: FILTER_ANY },
            ...Object.values(ISSUE_STATES)
              .filter((x) =>
                this.issues.some((issue) => issue.issueStatus === x)
              )
              .map((x) => ({ name: x, value: x })),
          ],
        },
        {
          field: "iid",
          text: "Link",
          sortable: false,
        },
        {
          field: "milestone",
          text: "Milestone",
          sortable: true,
        },
        {
          field: "category",
          text: "Component",
          filterType: FILTER_MULTI_SELECT,
          sortable: true,
          filter: [
            { name: "Any component (Reset)", value: FILTER_ANY },
            ...[...new Set(this.issues.flatMap((i) => i.category))]
              .sort()
              .map((x) => ({ name: x.replace("component:", ""), value: x })),
          ],
        },
        {
          field: "assignees",
          text: "Assignee",
          sortable: true,
          filterType: FILTER_MULTI_SELECT,
          filter: [
            { name: "Anyone", value: FILTER_ANY },
            { name: "Unassigned", value: FILTER_EMPTY_ARRAY },
            ...[...new Set(this.issues.flatMap((i) => i.assignees))]
              .sort()
              .map((x) => ({ name: x, value: x })),
          ],
        },
        {
          field: "labels",
          text: "Labels",
          filterType: FILTER_TEXT_SEARCH,
          sortable: false,
        },
      ];
    },
    isOngoing() {
      return this.data?.status === ONGOING;
    },
    peopleFields() {
      return this.isOngoing
        ? ["name", "assigned", "closed", "total"]
        : ["name", "closed"];
    },
    groupFields() {
      const [name, ...restOfFields] = this.peopleFields;

      return [
        name,
        this.showTeamMembers ? ["members"] : [],
        ...restOfFields,
        this.groups.some((x) => x.target > 0) ? ["target", "completion"] : [],
      ].flat();
    },
    total() {
      const total = { ...defaultStats };

      for (const e of this.pivot) {
        for (const key of Object.keys(total)) {
          total[key] += e[key];
        }
      }

      return total;
    },
    folks() {
      return this.pivot.flatMap((x) => {
        if (x.name === UNASSIGNED) {
          return [];
        }
        if (this.isOngoing || x.closed > 0) {
          return {
            ...x,
            total: (x.assigned || 0) + (x.closed || 0),
          };
        }
        return [];
      });
    },
    unassigned() {
      return this.pivot.find((x) => x.name === UNASSIGNED) || {};
    },
    groups() {
      const go = this.data?.groups || {};

      const { folks } = this;

      const groups = groupPeopleByTeam(folks, go);

      if (this.unassigned.closed) {
        groups.push({
          ...this.unassigned,
          name: "Unassigned issues",
          total: this.unassigned.closed,
          folks: [],
          groups: [],
          completion: -1,
        });
      }

      return groups;
    },
    issues() {
      const issues = Object.freeze(this.data?.issues) || [];

      return enhanceIssues(issues, this.isOngoing);
    },
    pivot() {
      const issues = this.issues;

      return groupByAssignee(issues);
    },
  },
};
</script>
